--------------------------------------------------------------------
---  Mail Opener
--   Author: Teli
-- 	 Version: 0.8
--   info: Grabs the attachments from the mail and optionally 
--			deletes the mail after grabbing the items
--    		can be set to grab only Raw Mats or all items
--
--
--------------------------------------------------------------------
PS = {}


PS.name = "PostalService"
PS.version = 1.0
PS.mailInfo = {}
PS.mailId = nil
PS.author = '@Teli' 


local nextMailId
local firstMailId
local numMail = 0
local getAll = false
local mailOpened = false
local GET_ATTACHMENTS
local stripDescriptor
local mailIndex = 0
local deleteMail = false

local containerIDs = {
	{['name']="Woodworker's Chest",['id']='30339',['type']='woodworking'},
	{['name']="Blacksmith's Chest",['id']='30335',['type']='blacksmithing'},
	{['name']="Clothier's Chest",['id']='30338',['type']='clothing'},
	{['name']="Enchanter's Chest",['id']='30337',['type']='enchanting'},
	{['name']="Brewer's Chest",['id']='30334',['type']='provisioning'}
}

local senders = {
	{['name']="Woodworker's Chest",['sender']='Pacrooti',['type']='woodworking'},
	{['name']="Blacksmith's Chest",['sender']='Valinka Stoneheaver',['type']='blacksmithing'},
	{['name']="Clothier's Chest",['sender']='Madam Firilanya',['type']='clothing'},
	{['name']="Enchanter's Chest",['sender']='Unknown',['type']='enchanting'},
	{['name']="Brewer's Chest",['sender']='Unknown',['type']='provisioning'}
}



function PS.InboxUpdate(eventCode)
	--InboxUpdate event code = 131329
	if PS.SV.debug then d('InboxUpdate ' .. tostring(eventCode)) end
	numMail = GetNumMailItems()
end
--    Event handler for EVENT_MAIL_READABLE event
function PS.MailReadable(eventCode, mailId)
	--MailReadable event code = 131331
	--if PS.SV.debug then d('MailReadable ' .. tostring(eventCode)) end
	
	if getAll then 
		zo_callLater(function() 
			d('mail read checking attachment')
			PS.ProcessMail('attachment')  
		end, PS.SV.buffer)
	end
end
--    Event handler for EVENT_MAIL_TAKE_ATTACHED_ITEM_SUCCESS event
function PS.TakeAttach(eventCode, mailId)
	--TakeAttach event code = 131339
	--if PS.SV.debug then d('TakeAttach ' .. tostring(eventCode)) end
	if getAll then 
		zo_callLater(function() 
			d('attachment taken checking for money')
			PS.ProcessMail('money') 
		end, PS.SV.buffer)
	end
end
--    Event handler for EVENT_MAIL_TAKE_ATTACHED_MONEY_SUCCESS event
function PS.TakeMoney(eventCode, mailId)
	if PS.SV.debug then d('TakeMoney ' .. tostring(eventCode)) end
	if getAll then 
		zo_callLater(function() 
			d('money taken checking for delete')
			PS.ProcessMail('delete')
		end, PS.SV.buffer)
	end	
end
--    Event handler for EVENT_MAIL_REMOVED event
function PS.MailRemoved(eventCode, mailId)
	--TakeAttach event code = 131338
	if PS.SV.debug then d('MailRemoved ' .. tostring(eventCode)) end
	if getAll then 
		zo_callLater(function() 
			d('mail deleted getting next mail')
			PS.ProcessMail('getnext')
		end, PS.SV.buffer)
	end
	numMail = GetNumMailItems()	
end

--    Event handler for EVENT_MAIL_OPEN_MAILBOX event
function PS.OpenMailbox(eventCode)
	PS.ShowKeybindStrip()
	numMail = GetNumMailItems()
	
	mailOpened = true
end

--    Event handler for EVENT_MAIL_CLOSE_MAILBOX event
function PS.CloseMailbox(eventCode)
	KEYBIND_STRIP:RemoveKeybindButtonGroup(stripDescriptor)
	mailOpened = false
end


function PS.ProcessMail(step)
	local mailId = PS.mailInfo[1]
	if getAll==false then return end
	if mailIndex > GetNumMailItems() then  
		getAll = false  
		return
	end
	if step == 'read' then
		mailIndex = mailIndex +1
		RequestReadMail(mailId)
		return
	end
	local senderDisplayName, senderCharacterName, subject,
		icon, unread, fromSystem, fromCustomerService, 
		returned, numAttachments, attachedMoney, codAmount, 
		expiresInDays, secsSinceReceived = GetMailItemInfo(mailId)
	local body = ReadMail(mailId)
	
	if step == 'attachment' then
		if numAttachments >  0 then
			local icon, stack, creatorName  = GetAttachedItemInfo(mailId,1) 
			local link = GetAttachedItemLink(mailId, 1, LINK_STYLE_DEFAULT)
			local  attachName, attachColor,_,attachId = ZO_LinkHandler_ParseLink(link)
			if PS.IsValidAttachment(PS.AttachmentType(attachId,senderDisplayName)) then
				deleteMail = true
				--PS.ProcessMail('money')
				--d('taking ' .. attachName)
				TakeMailAttachedItems(mailId)
				return
			else
				step = 'money'
			end
		else
			step = 'money'
		end
	end
	if step == 'money' then
		if 	attachedMoney >  0 then
			deleteMail = true
			TakeMailAttachedMoney(mailId)
			return
		else
			step = 'delete'
		end
	end
	if step == 'delete' then
		if PS.SV.deletemail and deleteMail then
			deleteMail = false
			DeleteMail(mailId,false)
			--d('deleting')
			--PS.ProcessMail('getnext')
			return
		else
			step = 'getnext'
		end
		deleteMail = false
	end
	if step == 'getnext' then
		table.remove(PS.mailInfo,1)
		deleteMail = false
		if next(PS.mailInfo) == nil then
			mailIndex = 0
			getAll = false
			return
		end
		PS.ProcessMail('read')			
		return
	end
end

function PS.Test(arg,arg2,arg3,arg4)
	local x = 0
	if arg == '2' then
		getAll = true
		nextMailId = GetNextMailId()
		firstMailId = nextMailId
		RequestReadMail(nextMailId)
	elseif arg == '3' then
	else
		PS.GetMailInfo()
		for k,v in pairs(PS.mailInfo) do
			x = x+ 1
			d(v)	
		end
		d(x)
	end
end

function PS.AttachmentType(attachId,senderCharacterName)
	for k,v in pairs(containerIDs) do
		if attachId ==v['id'] then
			return v['type']
		end
	end
	for k,v in pairs(senders) do
		if senderCharacterName ==v['sender'] then
			return v['type']
		end
	end
	return 'other'
end
function PS.IsValidAttachment(attachType)
	return PS.SV.mailtype[attachType]
end

function PS.GetAllAttach()
	if numMail == 0 then getAll = false return end
	if mailOpened == false then d('Mailbox must be opened first!') return end
	PS.GetMailInfo()
	getAll = true
	PS.ProcessMail('read')
end

function PS.GetMailInfo()
	numMail = GetNumMailItems()
	local mailId = nil
	local x = 0
	PS.mailInfo = {}
	mailId = GetNextMailId(mailId)
	for m = 1, numMail, 1 do
		table.insert(PS.mailInfo,mailId)
		mailId = GetNextMailId(mailId)
	end
	return PS.mailInfo
end

--------------------------------------------------------------------
--   PS.GetSavedVar()
--   PS.ChangeSavedVars(key,value)
--   PS.SavedVarExists(key)
--------------------------------------------------------------------
function PS.GetSavedVar(key)
	return PS.SV[key]
end
function PS.GetMailType(key)
	return PS.SV.mailtype[key]
end
function PS.ChangeMailType(key,value)
	if value == nil then return false end
	local tbl = PS.SV.mailtype
	if PS.MailTypeExists(key) then
		local oldValue = PS.ToBoolean(tbl[key])
		if oldValue ~= nil then 
			tbl[key] = PS.ToBoolean(value)
			if PS.SV.debug then d('changed ' .. key  ..  ' to ' .. tostring(value)) end
			return true
		end
	end
	return false
end	
function  PS.MailTypeExists(key)
	local tbl = PS.SV.mailtype
	for k,v in pairs(tbl) do
		if key == k then 
			return true
		end
	end
	return false
end
function PS.ChangeSavedVars(key,value)
	if value == nil then return false end
	local tbl = PS.SV
	if PS.SavedVarExists(key) then
		local ty = type(tbl[key])
		if ty == 'boolean' and PS.ToBoolean(value) ~= nil then 
			if PS.SV.debug then d('changed ' .. key  ..  ' to ' .. tostring(value)) end
			tbl[key] = PS.ToBoolean(value)
			return true
		elseif ty == 'number' and tonumber(value) ~= nil then 
			if PS.SV.debug then d('changed ' .. key  ..  ' to ' .. tostring(value)) end
			tbl[key] = tonumber(value)
		end
	end
	return false
end
function  PS.SavedVarExists(key)
	local tbl = PS.SV['default']
	for k,v in pairs(tbl) do
		if key == k then 
			return true
		end
	end
	return false
end
function PS.ToBoolean(s)
	if s == 'true'  or s == true or s==1 then
		return true
	elseif s == 'false' or s == false or s ==0 then
		return false
	else
		return nil
	end
end
function PS.ShowKeybindStrip()
	KEYBIND_STRIP:AddKeybindButtonGroup(stripDescriptor)
	GET_ATTACHMENTS = KEYBIND_STRIP.keybinds.PS_GET_ATTACHMENTS
end
	
	
--------------------------------------------------------------------
---  commandHandler function
--       input: text (Commands)
-- 
-- info:
--    This is the commandHandler, it accepts ANY length of input
--    It will separate the input into 'words' separated by a space
--    To make multi-word commands.
--
--------------------------------------------------------------------
function PS.commandHandler(text)
 -- put everything in lowercase to let the command handler accept
 -- "LIST" and "list" as the same, for example.
	local input = string.lower(text)
	-- set up some variables
	local com = {}
	local index = 1
 -- separate arguments from 'text' into the 'com' table
	if text~=nil then  -- if text not equals NIL we continue
	-- Here we put each input separated by a space into their own line
	-- in the "com" table.
		for value in string.gmatch(input,"%w+") do  
			com[index] = value
				index = index + 1
		end
	end
	if com[1]=="test" and PS.SV.debug then
		PS.Test(com[2],com[3],com[4])
	elseif com[1] =='debug' then
		PS.ChangeSavedVars(com[1],not PS.SV.debug)
		if PS.SV.debug then
			d('debug mode enabled\nReloading in 2 seconds')
			zo_callLater(function() ReloadUI("ingame") end, 2000)
		else
			d('debug mode diabled')
		end
	elseif PS.MailTypeExists(com[1]) and PS.SV.debug then
		PS.ChangeMailType(com[1],com[2])
	elseif PS.SavedVarExists(com[1]) and PS.SV.debug then
		PS.ChangeSavedVars(com[1],com[2])
	else
		d('Settings are located under the Main Menu Settting Postal Service')
		if PS.SV.debug then
			d('debug mode enabled type /ps debug \nto exit debug mode ')
		else
			d('debug mode disabled type /postalservice debug \nto enter debug mode ')
		end
	end
end

--------------------------------------------------------------------
---  PS.Initialize function
--       input: eventCode, addOnName
-- 
-- info:
--   Initializes the addon and savedvariables, 
--------------------------------------------------------------------
function PS.initialize( eventCode, addOnName )
-- If the addOnName and the name of our PS.name variable do not match
-- We end the initialize function, and the addon will not get loaded further.
    if ( addOnName ~= PS.name ) then return end        
	-- register events
	EVENT_MANAGER:RegisterForEvent("postalService", EVENT_MAIL_OPEN_MAILBOX, PS.OpenMailbox)
	EVENT_MANAGER:RegisterForEvent("postalService", EVENT_MAIL_CLOSE_MAILBOX, PS.CloseMailbox)
	EVENT_MANAGER:RegisterForEvent("postalService", EVENT_MAIL_REMOVED, PS.MailRemoved)
	EVENT_MANAGER:RegisterForEvent("postalService",  EVENT_MAIL_TAKE_ATTACHED_ITEM_SUCCESS, PS.TakeAttach)
	EVENT_MANAGER:RegisterForEvent("postalService",  EVENT_MAIL_TAKE_ATTACHED_MONEY_SUCCESS, PS.TakeMoney)
	EVENT_MANAGER:RegisterForEvent("postalService",  EVENT_MAIL_READABLE, PS.MailReadable)
	EVENT_MANAGER:RegisterForEvent("postalService",  EVENT_MAIL_INBOX_UPDATE, PS.InboxUpdate)

	-- Saved vars
	local defaults =
	{
		['buffer']=800,
		['deletemail']=false,
		['debug']=false,
		['mailtype'] = {
			['blacksmithing']=false,
			['clothing']=true,
			['enchanting']=true,
			['provisioning']=true,
			['woodworking']=false,
			['money'] = true,
			['other']=false
			}
	}
	PS.SV = ZO_SavedVars:New("PS_SavedVariables", 2.1, nil, defaults)
	
	--Register slash commands
	SLASH_COMMANDS["/postalservice"] = PS.commandHandler
	if PS.SV.debug then SLASH_COMMANDS["/ps"] = PS.commandHandler end
	
	--Keybinding
	ZO_CreateStringId("SI_BINDING_NAME_PS_GET_ATTACHMENTS", "Get Attachments")
	stripDescriptor = 
		{
			{
				alignment = KEYBIND_STRIP_ALIGN_CENTER,
				name = 'Get All',
				keybind = "PS_GET_ATTACHMENTS",
				callback = function() 
				PS.GetAllAttach()
				end,
			}
		}
	PSMenu.Init()
	if mailOpen ~= nil then 
		zo_callLater(function() d('Postal Service: You still have MailOpener installed please uninstall MailOpener or disable it') end, 3000)
	end
end  -- end of PS.Initialize function

--Register events
EVENT_MANAGER:RegisterForEvent("postalService",EVENT_ADD_ON_LOADED,PS.initialize)