
PSMenu = {}
local LAM = LibStub("LibAddonMenu-1.0")


function PSMenu.Init()
	PSMenu.panelID = LAM:CreateControlPanel("PSOptions", "Postal Service")
	LAM:AddHeader(PSMenu.panelID, "PSHeader", "SETTINGS")
	LAM:AddCheckbox(PSMenu.panelID, 'PSDeleteMail', 'Delete Mail', 'Delete mail after grabbing attachments', 
		function() 
			return PS.GetSavedVar('deletemail')
		end, 
		function(val) 
			PS.ChangeSavedVars('deletemail',val) 
		end)
	LAM:AddEditBox(PSMenu.panelID,'PSBuffer', 'Buffer', 'Buffer to add inbetween taking actions. This is needed to ensure that the actions process in order', false,
		function() 
			return PS.GetSavedVar('buffer')
		end,
        function(val) 
			PS.ChangeSavedVars('buffer',val) 
		end)
	LAM:AddHeader(PSMenu.panelID, "PSAttach", "Attachment Types")
	LAM:AddCheckbox(PSMenu.panelID, 'PSBlacksmithing', 'Blacksmithing', 'Grab blacksmithing chests from attachments', 
	function() 
		return PS.GetMailType('blacksmithing')
	end, 
	function(val) 
		PS.ChangeMailType('blacksmithing',val) 
	end)
	LAM:AddCheckbox(PSMenu.panelID, 'PSClothing', 'Clothing', 'Grab clothing chests from attachments', 
	function() 
		return PS.GetMailType('clothing')
	end, 
	function(val) 
		PS.ChangeMailType('clothing',val) 
	end)
	LAM:AddCheckbox(PSMenu.panelID, 'PSWoodworking', 'Woodworking', 'Grab woodworking chests from attachments', 
	function() 
		return PS.GetMailType('woodworking')
	end, 
	function(val) 
		PS.ChangeMailType('woodworking',val) 
	end)
	LAM:AddCheckbox(PSMenu.panelID, 'PSEnchanting', 'Enchanting', 'Grab enchanting chests from attachments', 
	function() 
		return PS.GetMailType('enchanting')
	end, 
	function(val) 
		PS.ChangeMailType('enchanting',val) 
	end)
	LAM:AddCheckbox(PSMenu.panelID, 'PSProvisioning', 'Provisioning', 'Grab provisioning chests from attachments', 
	function() 
		return PS.GetMailType('provisioning')
	end, 
	function(val) 
		PS.ChangeMailType('provisioning',val) 
	end)
	LAM:AddCheckbox(PSMenu.panelID, 'PSMoney', 'Money', 'Grab money from attachments', 
	function() 
		return PS.GetMailType('money')
	end, 
	function(val) 
		PS.ChangeMailType('money',val) 
	end)
	LAM:AddCheckbox(PSMenu.panelID, 'PSOther', 'Other', 'Grab all other attachments', 
	function() 
		return PS.GetMailType('other')
	end, 
	function(val) 
		PS.ChangeMailType('other',val) 
	end)
	LAM:AddHeader(PSMenu.panelID, "PSAboutHeader", "")
	LAM:AddDescription(PSMenu.panelID, 'PSAbout', 'Addon created by ' .. PS.author .. '\nQuestions or comments message ' .. PS.author .. ' in game NA')
end

function PSMenu.Get()
	return true
end

function PSMenu.Set()
	d('set')
	return true
end